// Utils.cpp: implementation of the CKeysSe class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Carrom.h"
#include "Utils.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CTime
//////////////////////////////////////////////////////////////////////
CTimer::CTimer()
{
	Rate=1;
	Start();
}
void CTimer::Start()
{
	StopWatch=Current();
	Paused=false;
}
void CTimer::Pause(bool Pause)
{
	if (Paused==Pause) return;
	if (Pause)
	{
		PausedAt=Current();
		Paused=true;
	}
	else
	{
		StopWatch+=Current()-PausedAt;
		Paused=false;
	}
}
void CTimer::SetRate(float NewRate)
{
	float Cur=Current();
	StopWatch=Cur-(Cur-StopWatch)*Rate/NewRate;
	Rate=NewRate;
}
//////////////////////////////////////////////////////////////////////
// CKeysSet
//////////////////////////////////////////////////////////////////////
bool CKeysSet::Add(UINT Key)
{
	if (Has(Key)) return true;
	if (NumKeys==150) return false;
	Keys[NumKeys++]=Key;
	return true;
}
void CKeysSet::Remove(UINT Key)
{
	int i;
	for (i=0; i<NumKeys && Keys[i]!=Key; i++);
	if (i==NumKeys) return;
	NumKeys--;
	for ( ; i<NumKeys; i++)
		Keys[i]=Keys[i+1];
}
bool CKeysSet::Has(UINT Key)
{
	for (int i=0; i<NumKeys && Keys[i]!=Key; i++);
	return (i!=NumKeys);
}
//////////////////////////////////////////////////////////////////////
// Global functions
//////////////////////////////////////////////////////////////////////
/*
void TransBlt(CDC *dc,int x,int y,int cx,int cy,CBitmap *Bmp,CBitmap *Mask)
{
	CDC dcBmp,dcMask;
	CBitmap *pOldB,*pOldM;
	dc->SetTextColor(0);
	dc->SetBkColor(0xFFFFFF);
	dcBmp.CreateCompatibleDC(dc); pOldB=dcBmp.SelectObject(Bmp);
	dcMask.CreateCompatibleDC(dc); pOldM=dcMask.SelectObject(Mask);
	dc->BitBlt(x,y,cx,cy,&dcBmp,0,0,SRCINVERT);
	dc->BitBlt(x,y,cx,cy,&dcMask,0,0,SRCAND);
	dc->BitBlt(x,y,cx,cy,&dcBmp,0,0,SRCINVERT);
	dcBmp.SelectObject(pOldB);
	dcMask.SelectObject(pOldM);
}
*/