// Utils.h: interface for the CKeysSe class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_UTILS_H__3EE09FC1_7084_11D5_8548_EDBA2981AC6E__INCLUDED_)
#define AFX_UTILS_H__3EE09FC1_7084_11D5_8548_EDBA2981AC6E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////
// Start of my code
//////////////////////////////////////////////////////////////////////
#include <mmsystem.h>
#include "Board.h"
//////////////////////////////////////////////////////////////////////
// CTime
//////////////////////////////////////////////////////////////////////
class CTimer
{
private:
	float StopWatch;
	bool Paused;
	float PausedAt;
	float Rate;
public:
	float Current() {return (float)timeGetTime()/1000;}
	CTimer();
	void Start();
	float GetPeriod() {return (Current()-StopWatch)*Rate;}
	void Pause(bool Pause);
	bool IsPaused() {return Paused;}
	void SetRate(float NewRate);
	void SetTime(float Secs) {StopWatch=Current()-Secs/Rate;}
};
//////////////////////////////////////////////////////////////////////
// CKeySet
//////////////////////////////////////////////////////////////////////
class CKeysSet
{
private:
	UINT Keys[150];	// Virtual key codes (how many are actually there??)
	int NumKeys;
public:
	CKeysSet() {NumKeys=0;}
	bool Add(UINT Key);
	void Remove(UINT Key);
	bool Has(UINT Key);
	bool operator [](UINT Key) {return Has(Key);}
	void Clear() {NumKeys=0;}
};
//////////////////////////////////////////////////////////////////////
// End of my code
//////////////////////////////////////////////////////////////////////

#endif // !defined(AFX_UTILS_H__3EE09FC1_7084_11D5_8548_EDBA2981AC6E__INCLUDED_)
